/*
Programm: Aufg.FeldOhneDuplikate
Zweck:    entfernt die Duplikate aus einem Feld von 10 eingegebenen Zahlen und gibt es aus
Aufgabe:  Entspricht dem Punkt "5.9.3 Aufgabe 3" Punkt 1 im 
          Skript "Programmieren 1" von Prof. Letschert, in der 
          Version vom 2001-09-10
Autor:    Mattias Ansorg <ansis@gmx.de>
Lizenz:   public domain
Datum:    2001-12-02
*/


#include <iostream>
using namespace std;

int main () {
   int     zf[10]; // das Zahlenfeld
   int     dbl=10, // zf[dbl] .. zf[9] enthaelt Duplikate
           sgl=-1,  // zf[0] .. zf[sgl] enthaelt jedes Element nur einmal
           comp,   // pruefe Gleicheit mit zf[comp]
           help;   // Hilfsvariable zum Elementtausch
   bool    nochmal=false;

   // Eingabe des Zahlenfeldes
   for (int i=0; i<10; ++i) {
      cout << "Bitte " << i+1 << " Zahl eingeben: ";
      cin >> zf[i];
   }

   // Eliminieren der doppelten Elemente durch Trennen in einen Single- und Duplikatbereich

   // bis Single- und Duplikatbereich zusammenstoen:
   while (sgl+1 != dbl) {
      // pruefe, ob zf[sgl+1] nochmal vorkommt in zf[sgl+2] .. zf[dbl-1]
      comp=sgl+2;
      nochmal=false;
      while (comp<=dbl-1 && !nochmal) {
         if (zf[sgl+1] == zf[comp]) {
            nochmal=true;
            cout << "debug: nochmal auf true gesetzt, da " << zf[sgl+1] << "==" << zf[comp] << endl;
         }
         ++comp;
      }

      // wenn zf[sgl+1] nochmal vorkommt, verfrachte es in den Duplikatbereich
      if (nochmal) {
         help = zf[sgl+1];
         zf[sgl+1] = zf[dbl-1];
         zf[dbl-1] = help;
         --dbl;
      }
      // Ansonsten verfrachte es in den Singlebereich
      else ++sgl;
   }

   // Ausgabe der Elemente im Singlebereich des Zahlenfeldes
   for (int i=0; i<=sgl; ++i) {
      cout << i+1 << ". verschiedene Zahl: " << zf[i] << endl;
   }
} 
