/*
Programm: Aufg.Fibonacci
Zweck:    Berechnet die ersten 20 Fibonacci-Zahlen und gibt sie aus
Aufgabe:  Entspricht dem Punkt "5.9.2 Aufgabe 2" im 
          Skript "Programmieren 1" von Prof. Letschert, in der 
          Version vom 2001-09-10
Autor:    Mattias Ansorg <ansis@gmx.de>
Lizenz:   public domain
Datum:    2001-12-02
*/


#include <iostream>
using namespace std;

int main () {
   int fib[20]; // wird belegt mit den ersten 20 Fibnoacci-Zahlen

   // Berechnung der Fibonacci-Zahlen
   fib[0] = 0; // 1. Startwert
   fib[1] = 1; // 2. Startwert
   for (int i=2; i<20; ++i) {
      fib[i] = fib[i-2] + fib[i-1];
   }

   // Ausgabe des Feldes
   cout << "Die ersten 20 Fibonacci-Zahlen sind:\n";
   for (int i=0; i<20; ++i) {
      cout << "fib(";
      cout.width(2);
      cout << i << ")= ";
      cout.width(5);
      cout << fib[i] << endl;
   }
} 
