/*
Programm: Aufg.NaeherungEX
Zweck:    Berechnet eine Naeherung der Zahl e^x nach der Folge
          e^x = x^0/0! + x^1/1! + x^2/2! + ...
Aufgabe:  Entspricht dem Punkt "3.10.5 Aufgabe 5" Punkt 1 im 
          Skript "Programmieren 1" von Prof. Letschert, in der 
          Version vom 2001-09-10
Autor:    Mattias Ansorg <ansis@gmx.de>
Lizenz:   public domain
Datum:    2001-11-24
*/


#include <iostream>
#include <cmath>
using namespace std;

int main () {

   const float delta=0.1;
   float ex=1, ex_alt;
   int  n=0, x;
   long  n_fak=1;

   cout << "Bitte x zur Berechnung von e^x eingeben: ";
   cin >> x;

   do {
      ex_alt = ex;
      ++n;
      n_fak = n_fak * n;
      ex = ex + pow(x,n) / float (n_fak);
      cout << "debug: Schleifendurchlauf " << n << endl;
      cout << "debug: ex = " << ex_alt << "+" << pow(x,n) << "/" << n_fak << endl;
      cout << "debug: going for " << ex << " - " << ex_alt << " > " << delta << endl;
   } while (ex - ex_alt > delta); 


   cout << "Nherung an e^" << x << ": " << ex << endl;
}
