/*
Programm: Aufg.ProduktIterativ
Zweck:    Iterative Alternative zur rekursiven Berechnung eines Produktes
Aufgabe:  Entspricht dem Punkt "8.9.2 Aufgabe 2" Punkt 5 im 
          Skript "Programmieren 1" von Prof. Letschert, in der 
          Version vom 2001-09-10
Autor:    Mattias Ansorg <ansis@gmx.de>
Lizenz:   public domain
Datum:    2001-12-12
*/


#include <iostream>
using namespace std;

// Vorbedingung: a>=0
int f1(int a, int b) {
   int product=b;
   for (int i=1; i<a; ++i) {
      // INV: product=i*b
      product+=b;
   }
   // product=i*b mit i=a: product=a*b
   return product;
}

int main () {
   int x,y;
   cout << "Bitte ersten Faktor x>=0 eingeben: ";
   cin >> x;
   cout << "Bitte zweiten Faktor y eingeben: ";
   cin >> y;
   cout << "Das Produkt ist " << f1(x,y) << endl;
}

