/*
Programm: Aufg.TabelleUngeradeZahlen
Zweck:    Gibt die ungeraden Zahlen in einer Tabelle aus, in der jede 
          Zeile eine Spalte mehr enthaelt, und berechnet die Zeilen-
          summen sum(i) der Zeilen i zur Pruefung der Hypothese sum=i^3
Aufgabe:  Entspricht dem Punkt "3.10.8 Aufgabe 8" im 
          Skript "Programmieren 1" von Prof. Letschert, in der 
          Version vom 2001-09-10
Autor:    Mattias Ansorg <ansis@gmx.de>
Lizenz:   public domain
Datum:    2001-11-24
*/

#include <iostream>
#include <cmath>
using namespace std;

int main () {
   int i_max,  // auszugebende Zeilen
       uzahl;  // aktuelle ungerade zahl

   // auszugebende Zeilenzahl einlesen
   cout << "Wieviele Zeilen ausgeben?: ";
   cin >> i_max;

   // Alle Zeilen ausgeben, inkl. Zeilensumme
   uzahl=1;
   for (int i=1; i<=i_max; ++i) {
      // Eine Zeile mit Zeilensumme ausgeben
      int i_sum=0;
      cout << "Zeile " << i << ":    ";
      for (int spalten=1; spalten<=i; ++spalten) {
         // Ein Element ausgeben
         i_sum = i_sum + uzahl;
         cout << " " << uzahl;
         uzahl+=2;
      }
      cout << endl << "Zeilensumme: " << i_sum << endl;
      cout << "Zahl " << i << "^3=    " << int(pow(i,3)) << endl << endl;
   }
} 
