/*
Programm: Aufg.TeilerProbe
Zweck:    Ermittelt mit +, - und Relationen, ob eine Zahl t (zahl1) eine 
          Zahl n (zahl2) ganzzahlig ohne Rest teilt
Aufgabe:  Entspricht dem Punkt "3.10.11 Aufgabe 11" Punkt 2 im 
          Skript "Programmieren 1" von Prof. Letschert, in der 
          Version vom 2001-09-10
Autor:    Mattias Ansorg <ansis@gmx.de>
Lizenz:   public domain
Datum:    2001-11-25
*/


#include <iostream>
using namespace std;

int main () {
   // Idee: Verwende Aufg.GeradeZahl.cc und verallgemeinere; statt der Pruefung, ob 
   // ganzzahlig durch 2 geteilt werden kann, pruefe, ob ganzzahlig durch t 
   // geteilt werden kann

   float zahl1,         // Dividend; ist er durch zahl2 ganzzahlig teilbar?
         zahl2,         // Divisor
         zahl2_folge=0; // nimmt die Folge 0*zahl2, 1*zahl2, 2*zahl2, 3*zahl2, ... an

   // Eingabe
   cout << "Bitte zahl1 eingeben: ";
   cin >> zahl1;
   cout << "Bitte zahl2 eingeben: ";
   cin >> zahl2;

   while (zahl2_folge < zahl1) {
      // INV: zahl2_folge = <anzahl_schleifendurchgaenge> * zahl2;
      //      AND zahl2_folge < zahl1
      zahl2_folge+=zahl2;
   }
   // zahl2_folge = n*zahl2 >= zahl1

   switch (zahl2_folge == zahl1) {
      case true:  cout << zahl1 << " ist ohne Rest durch " << zahl2 << " teilbar\n"; break;
      case false: cout << zahl1 << " ist nicht ohne Rest durch " << zahl2 << " teilbar\n"; break;
   }
}
