/*
Programm: Aufg.Zahlsystemwandlung
Zweck:    wandelt (n zur Basis b) in (m zur Basis 10) um und gibt m aus
Aufgabe:  Entspricht dem Punkt "4.10.7 Aufgabe 7" im 
          Skript "Programmieren 1" von Prof. Letschert, in der 
          Version vom 2001-09-10
Autor:    Mattias Ansorg <ansis@gmx.de>
Lizenz:   public domain
Datum:    2001-11-28
*/


#include <iostream>
#include <string>
using namespace std;

int main () {
   string s;         // eingelesene Zahl zur Basis b
   int b,            // eingelesene Basis, gehoert zur Zahl im String s
       ziffer,       // eine Stelle von s umgewandelt ins Zehnersystem
       potenz;       // Zehnerpotenz der aktuellen Nachkomma-Dezimalstelle
   float zahl=0;     // enthaelt s zur Basus b umgewandelt ins Zehnersystem
   bool vorkomma=1;  // Vor- oder Nachkommartithmetik?

   // Eingabe
   cout << "Umwandlung von Zahlen eines beliebigen Zahlensystems ins Zehnerssystem\n";
   cout << "Bitte Zahl eingeben: ";
   cin >> s;
   cout << "Bitte Basis eingeben zwischen 2 und 16: ";
   cin >> b;

   // Basis ueberpruefen (s wird bei der Umwandlung on the fly geprueft)
   if ((b>=2) || (b<=16)) {
      for (int pos=0; pos<int(s.length()); ++pos) {
         switch (s.at(pos)) {
            case ',': case '.': 
                      vorkomma=false; break;
            // Ziffer in eine Zahl im Zehnersystem umwandeln:
            case '0': case '1': case '2': case '3': case '4':
            case '5': case '6': case '7': case '8': case '9':
                      ziffer = int(s.at(pos))-48; 
                      break;
            case 'A': case 'B': case 'C': case 'D': case 'E': 
                      ziffer = int(s.at(pos))-55;
                      break;
            default:  cout << "Eingabefehler an Stelle " << pos+1 << " wird ignoriert\n"; break;
         }
         cout << "debug: Der Wert der Ziffer im Zehnersystem ist: " << ziffer << endl; 
         if (s.at(pos) != ',') {
            if (ziffer>=b) {
                  cout << "Eingabefehler an Stelle " << pos+1 << " wird ignoriert\n"; break;
               }
               else {
                  switch (vorkomma) {
                     case true:  zahl= zahl*b + ziffer; break;
                     case false: zahl= zahl   + float(ziffer)/potenz; potenz*=10;
                     // Nachkommazahlen werden noch nicht umgewandelt, irgendwo ist da ein Fehler
                  }
               }
         }
      }
   // berechnete Zahl im Zehnersystem ausgeben 
   cout << "Der Wert der Zahl im Zehnersystem ist: " << zahl << endl;
   }
   else {
      cout << "Eingabefehler bei Eingabe der Basis\n";
   }
}
