/*
Programm: Aufg.nkRekursiv
Zweck:    Berechnet "n ueber k" rekursiv
Aufgabe:  Entspricht dem Punkt "8.9.1 Aufgabe 1" Punkt 2 im 
          Skript "Programmieren 1" von Prof. Letschert, in der 
          Version vom 2001-09-10
Autor:    Mattias Ansorg <ansis@gmx.de>
Lizenz:   public domain
Datum:    2001-12-08
*/


#include <iostream>
using namespace std;

int nk(int n, int k);

int main () {
   int n,k;
   cout << "Bitte n eingeben: ";
   cin >> n;
   cout << "Bitte k eingeben: ";
   cin >> k;
   if (k>=0 && n>=k) // Vorbedingung pruefen
      cout << "n ber k ist: " << nk(n,k) << endl;
   else
      cout << "n ber k nicht berechenbar, da nicht 0 <= n <= k\n";
} 

// Vorbedingung:  0 <= k <= n
// Nachbedingung: 0 <= k <= n
int nk(int n, int k) {
  if (k==0 || n==k) return 1;
  else return nk(n-1,k) + nk(n-1,k-1);
}

