/*
Programm: Aufg.BimPam
Zweck:    Test eines vorgegebenen Programms
Aufgabe:  Entspricht dem Punkt "7.10.1 Aufgabe 1" Punkt 11 im 
          Skript "Programmieren 1" von Prof. Letschert, in der 
          Version vom 2001-09-10
Autor:    Mattias Ansorg <ansis@gmx.de>
Lizenz:   public domain
Datum:    2001-12-06
*/

#include <iostream>

namespace Bim {
   int b = 1;
}

namespace Pam {
   int p = 2; 
} 

int b = 3; 
int p = 4; 

void f() { 
   int p;                    // ueberdeckt ::p
   using Bim::b;             // ueberdeckt ::b, da "von innen nach aussen" vor ::b gefunden
   using namespace Pam;      // ueberdeckt lokales p, da "von innen nach auen" vorher gefunden
   p = 10*p + ::p + Pam::p;  // p ist Pam::p
   b = 10*b + ::b + Bim::b;  // b ist Bim::b
} 

int main () {
   int b = 10; 
   f(); 
   std::cout << "b= " << b << std::endl 
             << "::b= " << ::b << std::endl 
             << "::p= " << ::p << std::endl 
             << "Bim::b= " << Bim::b << std::endl 
             << "Pam::p= " << Pam::p << std::endl; 
}
