/*
Programm: Aufg.BitmusterInt
Zweck:    Gibt das Bitmuster einer int-Zahl aus, unter Vernachlssigung der Byteordnung
Aufgabe:  Entspricht dem Punkt "4.10.6 Aufgabe 6" im 
          Skript "Programmieren 1" von Prof. Letschert, in der 
          Version vom 2001-09-10
Autor:    Mattias Ansorg <ansis@gmx.de>
Lizenz:   public domain
Datum:    2001-11-28
*/


#include <iostream>
#include<cmath>
using namespace std;

int main () {
   int i;
   const unsigned int hbitval= 1 << sizeof(int)*8-1;
                      //     = pow(2,sizeof(int)*8-1)-1;
                      // Zahlwert des hoechsten Bits eines Integers
                      // entspricht Binaerdarstellung 1000.....0000
   cout << "Bitmuster ausgeben von: ";
   cin >> i;
   cout << "Das Bitmuster ist:\n";

   // bitweise ausgeben
   for (unsigned int z=hbitval; z!=0; z = z>>1) {
      // cout << "\ndebug: hbitval= " << hbitval << " z= " << z << endl;
      // cout << bool(i&z);
	   cout << bool(i&z);
   }
   cout << endl;
}
