/*
Programm: Aufg.FolgeFx
Zweck:    Berechnet die Folge aus der Aufgabenstellung
Aufgabe:  Entspricht dem Punkt "3.10.9 Aufgabe 10" im 
          Skript "Programmieren 1" von Prof. Letschert, in der 
          Version vom 2001-09-10
Autor:    Mattias Ansorg <ansis@gmx.de>
Lizenz:   public domain
Datum:    2001-11-25
*/


#include <iostream>
#include <cmath>
using namespace std;

int main () {
float x,            // Argument der Funktion
      fx,           // Folge- bzw. Funktionswert
      fx_alt,       // Alter Folgewert
      zahl,         // Wert 1+(fx)^2 in der Folge
      sqrt,         // Wert sqrt(zahl) in der Folge
      sqrt_alt,     // Alter Wert sqrt
      pow_2n=1;     // pow(2,n)
int   n= 0;         // zaehlt die Naeherungen
const float eps=0.0001; 
                    // vorgegebene Genauigkeit fuer Naeherungswerte

   // x einlesen
   cout << "Bitte Argument der Funktion eingeben: ";
   cin >> x;
   
   // berechne den Wert der Folge x_n in der Variablen fx
   fx=x;
   do {
      fx_alt=fx;

      // Berechne die Wurzel aus 1+(fx)^2 nach Heron-Verfahren
      zahl = 1 + fx*fx;
      sqrt=1;
      do {
         sqrt_alt = sqrt;
         sqrt = (sqrt + zahl / sqrt) / 2;
      } while (fabs(sqrt_alt - sqrt) > eps);
   
      // Jetzt berechne Naeherung des Folgewertes
      fx = fx / ( 1 + sqrt);

      ++n;
   } while (fabs(fx_alt - fx) > eps);

   // berechne 2^n in der Variablen pow_2n 
   for (int i=1; i<=n; ++i) {
      pow_2n = pow_2n * 2;
   }

   // berechne f(x)
   fx= pow_2n * fx;
   
   // Funktionswert ausgeben
   cout << "f(x) ist " << fx << endl;
} 
