/*
Programm: Aufg.GeradeZahl
Zweck:    Ermittelt mit +, - und Relationen, ob eine Zahl gerade ist
Aufgabe:  Entspricht dem Punkt "3.10.11 Aufgabe 11" Punkt 1 im 
          Skript "Programmieren 1" von Prof. Letschert, in der 
          Version vom 2001-09-10
Autor:    Mattias Ansorg <ansis@gmx.de>
Lizenz:   public domain
Datum:    2001-11-25
*/


#include <iostream>
using namespace std;

int main () {
   // Idee: addiere so lange 2, bis eine Zahl gleich (-> gerade Zahl) oder groesser (-> ungerade Zahl) 
   // einer eingegebenen zu untersuchenden Zahl wird.

   float zahl,           // einzugebende Zahl; untersuche: Ist sie gerade?
         gerade_zahl=0;  // nimmt die Folge der geraden Zahlen an

   // zahl eingeben, die untersucht werden soll
   cout << "Bitte zu untersuchende Zahl eingeben: ";
   cin >> zahl; 

   while (gerade_zahl < zahl) {
      // INV: gerade_Zahl ist eine gerade Zahl
      gerade_zahl+=2;
   }

   switch (gerade_zahl == zahl) {
      case true:  cout << "Die Zahl " << zahl << " ist gerade\n"; break;
      case false: cout << "Die Zahl " << zahl << " ist nicht gerade\n"; break;
   }
}
