/*
Programm: Aufg.MatheMatrix
Zweck:    Implementiert einen Typ fr mathematische Matrizen, 
          d.h. mit Indizes beginnend von 1
Aufgabe:  Entspricht dem Punkt "8.9.3 Aufgabe 3" im 
          Skript "Programmieren 1" von Prof. Letschert, in der 
          Version vom 2001-09-10
Autor:    Mattias Ansorg <ansis@gmx.de>
Lizenz:   public domain
Datum:    2001-12-09
*/


#include <iostream>
using namespace std;

struct Matrix_3_2 {
   float matrix3x2[3][2];
   float wert(int,int);
   void  setze(int,int,float);
};

int main () {
   Matrix_3_2 a;
   float x; 
   a.setze(1, 1, 5.0); 
   x = a.wert (1,1);
   cout << "Wert an Stelle 1,1 der Matrix: " << x << endl;
} 


// liefert matrix3x2[zeile][spalte] (mathematische Indizierung)
// VORBEDINGUNG: zeile=1..3, spalte=1..2
float Matrix_3_2::wert(int zeile, int spalte) {
   return matrix3x2[zeile-1][spalte-1];
}

// setzt matrix3x2[zeile][spalte]=wert (mathematische Indizierung)
// VORBEDINGUNG: zeile=1..3, spalte=1..2
void Matrix_3_2::setze(int zeile, int spalte, float wert) {
   matrix3x2[zeile-1][spalte-1]=wert;
}
