/*
Programm: Aufg.Matrix3x4
Zweck:    Belegt eine 3x4-Matrix in bestimmter Art
Aufgabe:  Entspricht dem Punkt "8.9.3 Aufgabe 3" Punkte 2 und 3 im 
          Skript "Programmieren 1" von Prof. Letschert, in der 
          Version vom 2001-09-10
Autor:    Mattias Ansorg <ansis@gmx.de>
Lizenz:   public domain
Datum:    2001-12-09
*/


#include <iostream>
using namespace std;

typedef int Matrix3x4[3][4];
Matrix3x4 matrix;

void matrixsum();

int main () {
   for (int i=0; i<3; ++i)
      for (int j=0; j<4; ++j)
         matrix[i][j]=10*i+j;
   matrixsum();
} 

// ZWECK:         berechne Summe aller Werte in matrix
// VORBEDINGUNG:  globale Variable matrix vom Typ Matrix3x4
// SEITENEFFEKTE: keine
void matrixsum() {
  int summe=0;
   for (int i=0; i<3; ++i)
      for (int j=0; j<4; ++j)
         summe+=matrix[i][j];
   cout << "Summe aller Matrixelemente: " << summe << endl;
}
