/*
Programm: Aufg.NaeherungPi
Zweck:    Berechnet eine Naeherung von der Kreiszahl pi aus der Folge 
          pi/4 = 1/1 - 1/3 + 1/5 - 1/7 + 1/9 ...
Aufgabe:  Entspricht dem Punkt "3.10.5 Aufgabe 5" Punkt 1 im 
          Skript "Programmieren 1" von Prof. Letschert, in der 
          Version vom 2001-09-10
Autor:    Mattias Ansorg <ansis@gmx.de>
Lizenz:   public domain
Datum:    2001-11-24
*/


#include <iostream>
#include <cmath>
using namespace std;

int main () {

   const float delta=0.000000001;
   float pi=0, pi_alt;
   int folgeglied=1;
   int  i=0;

   do {
      pi_alt = pi;
      pi = pi + 1.0/folgeglied;
 
      // ersetze folgeglied durch:
      //    -- eine um 2 betragsgroessere Zahl:    |folgeglied| + 2
      //    -- mit anderem Vorzeichen:             -1 * <altesVorzeichen>*1
      folgeglied = -1 * folgeglied / abs(folgeglied) * (abs(folgeglied) +2);
      
      // cout << "debug: Folgeglied ist " << folgeglied << endl;
      // cout << "debug: Schleifendurchgang " << ++i << endl; 
      // cout << "debug: going for " << pi << "-" << pi_alt << "<" << "delta" << endl; 
   } while (fabs(pi - pi_alt) > delta);

   pi=pi*4;

   cout << "Nherung an Pi: " << pi << endl;
}
