/*
Programm: Aufg.PruefProgramm
Zweck:    Ueberpruefung einer Hypothese zur Variablenbelegung in einem
          Programm
Aufgabe:  Entspricht dem Punkt "5.9.5 Aufgabe 5" im 
          Skript "Programmieren 1" von Prof. Letschert, in der 
          Version vom 2001-09-10
Autor:    Mattias Ansorg <ansis@gmx.de>
Lizenz:   public domain
Datum:    2001-12-03
*/


#include <iostream>
#include<string>
using namespace std;

int main () {
   struct S1 { 
      int s_i; 
      char s_c[5]; 
   }; 
   struct S2 { 
      int s_i; 
      char s_c[5]; 
   }; 
   S1 a [10]; 
   S2 b [10]; 
   S1 s1a = {5, {'a' , 'b' , 'c' , 'd' , 'e' }}; 
   S1 s1b; 
   S2 s2; 
   string sss = "s_i"; 

   for (int i=0; i<10; i++){ 
      a[i] = s1a; 
   } 
   for (int i=0; i<10; i++){ 
      b[i].s_i = a[i].s_i;
//      b[i].s_i = a[b[i].s_i].s_i; 
      for (int j=0; j<5; j++) 
         b[i].s_c[j] = a[i].s_c[j]; 
   }

   // Ueberpruefung der Variablenbelegung durch Ausgabe

   cout << "Belegung von a\n{";
   for (int i=0; i<10; ++i) {
      cout << "{" << a[i].s_i << ",{";
      for (int j=0; j<5; ++j) {
         cout << "'" << a[i].s_c[j] << "' , ";
      }
      cout << "}},\n";
   }
   cout << "}\n\n";

   cout << "Belegung von b\n{";
   for (int i=0; i<10; ++i) {
      cout << "{" << b[i].s_i << ",{";
      for (int j=0; j<5; ++j) {
         cout << "'" << b[i].s_c[j] << "' , ";
      }
      cout << "}},\n";
   }
   cout << "}\n\n";

   cout << "Belegung von s1a\n"
        << "{" << s1a.s_i << ",{";
   for (int j=0; j<5; ++j) {
      cout << "'" << s1a.s_c[j] << "' , ";
   }
   cout << "}},\n\n";


   cout << "Belegung von sss\n"
        << sss;

   cout << "Belegung von s1b\n"
        << "{" << s1b.s_i << ",{";
   for (int j=0; j<5; ++j) {
      cout << "'" << s1b.s_c[j] << "' , ";
   }
   cout << "}},\n\n";

   cout << "Belegung von s2\n"
        << "{" << s2.s_i << ",{";
   for (int j=0; j<5; ++j) {
      cout << "'" << s2.s_c[j] << "' , ";
   }
   cout << "}},\n\n";

}
