/*
Programm: Aufg.Summe2i
Zweck:    Berechnet die Summe von i=0..k ber 2*i
Aufgabe:  Entspricht dem Punkt "3.10.4 Aufgabe 4" im 
          Skript "Programmieren 1" von Prof. Letschert, in der 
          Version vom 2001-09-10
Autor:    Mattias Ansorg <ansis@gmx.de>
Lizenz:   public domain
Datum:    2001-11-24
*/


#include <iostream>
using namespace std;

int main () {
   int i=0,       // Schleifenzaehler
       i_grenz,   // eingegebener Endwert von i
       sum=0;     // bisherige Teilsumme

   cout << "Berechne Summe ber 2i von von i=0 bis: ";
   cin >> i_grenz;

   while (i < i_grenz) {
      // INV: sum = Summe 0..i ueber 2i;
      //   sum(i) = sum(i-1) + i mit sum(0)=0;
      ++i;
      sum = sum + 2*i;
   }
  
   cout << "Summe i=0.." << i_grenz << " ber 2i : " << sum << endl;
} 
