/*
Programm: Aufg.SwapSort
Zweck:    Funktion zur aufsteigenden Sortierung von 3 Parametern
Aufgabe:  Entspricht dem Punkt "7.10.1 Aufgabe 1" Punkt 9 im 
          Skript "Programmieren 1" von Prof. Letschert, in der 
          Version vom 2001-09-10
Autor:    Mattias Ansorg <ansis@gmx.de>
Lizenz:   public domain
Datum:    2001-12-06
*/


#include <iostream>
using namespace std;

void swapSort(int &a, int &b, int &c);
void swap(int &a, int &b);

int main () {
   int a[3] = {2,5,2};

   cout << "Vor dem Sortieren: \n";
   for (int i=0; i<3; ++i)
      cout <<  "a[" << i << "]= " << a[i] << endl;

   swapSort(a[0],a[1],a[2]);

   cout << "Nach dem Sortieren: \n";
   for (int i=0; i<3; ++i)
      cout <<  "a[" << i << "]= " << a[i] << endl;
}

void swapSort(int &a, int &b, int &c) {
   // BubbleSort mit 3 Elementen, sequentielle Ausfuehrung ohne Schleife
   if (a > b) 
      swap(a,b);  // tausche Inhalt von a,b
   if (b > c) {
      swap(b,c);
      if (a > b)
         swap(a,b);
   }
}

void swap(int &a, int &b) {
   int help=a;
   a=b;
   b=help;
}
