/*
Programm: Aufg.WieOft
Zweck:    eine Funktion kontrolliert, wie oft eine andere aufgerufen wurde
Aufgabe:  Entspricht dem Punkt "7.10.1 Aufgabe 1" Punkt 8 im 
          Skript "Programmieren 1" von Prof. Letschert, in der 
          Version vom 2001-09-10
Autor:    Mattias Ansorg <ansis@gmx.de>
Lizenz:   public domain
Datum:    2001-12-06
*/


#include <iostream>
using namespace std;

int aufrufe=0;

void mehr () {
   cout << "Neuer Aufruf von mehr()\n";
   ++aufrufe;  // globle Variable
}

int wieOft () {
   // Zahl der Aufrufe von mehr () seit dem letzten Aufruf von wieOft () zurueckgeben
   int aufrufe_copy = aufrufe;
   aufrufe = 0;
   // aufrufe zurueckgesetzt; Rueckgabewert noch in aufrufe_copy
   return aufrufe_copy;
}

int main () {
   for (int i=0; i<10; ++i) {
      for (int i=0; i<5; ++i)
         mehr();
      cout << wieOft() << " Aufrufe von mehr() seit letzter Pruefung\n";
   }
}
