/*
Programm: Aufg.WurzelHeron
Zweck:    Berechnet die Quadratwurzel nach dem Heron-Verfahren
Aufgabe:  Entspricht dem Punkt "3.10.9 Aufgabe 9" im 
          Skript "Programmieren 1" von Prof. Letschert, in der 
          Version vom 2001-09-10
Autor:    Mattias Ansorg <ansis@gmx.de>
Lizenz:   public domain
Datum:    2001-11-25
*/


#include <iostream>
using namespace std;

int main () {
   float sqrt=1,      // Naeherung an die Quadratwurzel
         alt_sqrt,    // vorheriger Naeherungswert von sqrt, zur Berechnung
         zahl;        // eingegebene Zahl, deren Wurzel berechnet werden soll
   const float eps=0.0001;   
                      // vorgegebene Genauigkeit, d.i. maximale Differenz von alt_sqrt - sqrt

   // zahl einlesen
   cout << "Berechne Wurzel aus : ";
   cin >> zahl;
  
   do {
      alt_sqrt = sqrt;
      sqrt = (sqrt + zahl / sqrt) / 2;
   } while ((alt_sqrt - sqrt > eps) || (sqrt - alt_sqrt > eps));
   
   cout << "Nherungswert der Wurzel aus " << zahl << " ist " << sqrt << endl;
} 
