/*
Programm: Aufg.ggT-Funktion
Zweck:    Funktion zur Berechnung des ggT aus zwei positiven ganzen Zahlen
Aufgabe:  Entspricht dem Punkt "6.6.1 Aufgabe 1" Punkt 4 im 
          Skript "Programmieren 1" von Prof. Letschert, in der 
          Version vom 2001-09-10
Autor:    Mattias Ansorg <ansis@gmx.de>
Lizenz:   public domain
Datum:    2001-12-04
*/


#include <iostream>
using namespace std;

int ggT(int a, int b);

int main () {
   int x,
       y;

   // Eingabe
   cout << "1. Zahl: ";
   cin  >> x;
   cout << "2. Zahl: ";
   cin  >> y;

   // Funktionsaufruf und Ausgabe
   if (x>=0 && y>=0) 
      cout << "Der ggT von " << x << " und " << y << " ist " << ggT(x,y) << endl;
   else
      cout << "ggT aus negativen Zahlen nicht berechenbar\n";
}

int ggT(int a, int b) {
   if (a==b) 
      // Rekursionsende
      return a;
   else 
      if (a>b)
         return ggT(a-b,b);
      else
         return ggT(a,b-a);
}
