/*
Programm: Aufg.kGroesstes
Zweck:    liest 10 Zahlen und k ein und gibt das k-groesste Element aus
Aufgabe:  Entspricht dem Punkt "5.9.3 Aufgabe 3" Punkt 2 im 
          Skript "Programmieren 1" von Prof. Letschert, in der 
          Version vom 2001-09-10
Autor:    Mattias Ansorg <ansis@gmx.de>
Lizenz:   public domain
Datum:    2001-12-02
*/


#include <iostream>
using namespace std;

int main () {
   int     zf[10]; // das Zahlenfeld
   int     k,      // das k-groesste Element soll bestimmt werden
           help;   // Hilfsvariable zum Elementtausch

   // Eingabe des Zahlenfeldes
   for (int i=0; i<10; ++i) {
      cout << "Bitte " << i+1 << " Zahl eingeben: ";
      cin >> zf[i];
   }

   // Eingabe von k
   cout << "Das k-grte Element suchen. Eingabe k=";
   cin >> k;
   --k;   // Normierung auf mit 0 beginnende Indizes

   // Bestimmen des k-groessten Elements
   
   // Sortiere das Feld absteigend k Elemente weit
   for (int i=0; i<=k && i<10; ++i) {
      // INV: zf[0..i-1] ist sortiert
      // zf[i] einsortieren: tausche zf[i] mit jedem zf[i+1 .. 9] > zf[i]
      for (int j=i+1; j<10; ++j) {
         if (zf[j] > zf[i]) {
            help=zf[i];
            zf[i]=zf[j];
            zf[j]=help;
         }
      }
   }
   // wenn zf[k-1] != zf[k], so ist zf[k] das k-groesste Element 
   // ansonsten gibt es kein k-groestes Element, ebenso wenn k>9
   if (k>9) {
      cout << "Es gibt in 10 Elementen kein " << k+1 << "-grtes\n";
   }
   else 
      if (zf[k-1] == zf[k]) {
         cout << "Es gibt kein " << k+1 << "-grtes Element\n";
      }
      else 
         cout << "Das " << k+1 << "-grte Element ist " << zf[k] << endl;
} 
